SystemOrganization addCategory: #'OB-Tests-Morphic'!

TestCase subclass: #OBBarMorphTest
	instanceVariableNames: 'bar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Morphic'!

!OBBarMorphTest methodsFor: 'simulating' stamp: 'cwp 3/11/2007 15:51'!
push: aString
	| button |
	button _ bar submorphs detect: [:b | b label contents = aString].
	button performAction! !

OBBarMorphTest subclass: #OBButtonBarTest
	instanceVariableNames: 'received'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Morphic'!

!OBButtonBarTest class methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2007 17:03'!
openBar
	self new setUp; openBarInWorld! !

!OBButtonBarTest methodsFor: 'callbacks' stamp: 'cwp 3/11/2007 16:52'!
cmd1
	received _ #cmd1! !

!OBButtonBarTest methodsFor: 'callbacks' stamp: 'cwp 3/11/2007 17:30'!
cmd3
	received = #cmd3! !

!OBButtonBarTest methodsFor: 'callbacks' stamp: 'cwp 3/11/2007 21:03'!
color
	^ Color red! !

!OBButtonBarTest methodsFor: 'callbacks' stamp: 'cwp 5/2/2007 23:07'!
commands
	^ 	{(OBPluggableCommand action: [self cmd1])
			buttonLabel: 'Command 1'.
		(OBPluggableCommand action: [self cmd3])
			buttonLabel: 'Command 3'.
		(OBPluggableCommand action: [self cmd4])
			buttonLabel: 'Command 4';
			active: [false]}! !

!OBButtonBarTest methodsFor: 'running' stamp: 'cwp 3/11/2007 17:02'!
openBarInWorld
	bar openInWorld.
	self changed: #commands.
	bar bounds: (100@100 corner: 400@140).
! !

!OBButtonBarTest methodsFor: 'running' stamp: 'cwp 3/11/2007 15:56'!
setUp
	bar _ OBButtonBar on: self.
	
			! !

!OBButtonBarTest methodsFor: 'testing' stamp: 'cwp 3/11/2007 17:02'!
testLayout
	| rects |
	
	"This is an ugly hack. I can't figure out how else to force a layout."
	self openBarInWorld.
	bar delete.

	rects _ bar submorphs collect: [:b | b bounds].
	self assert: rects first left = bar left.
	self assert: rects first right = rects second left.
	self assert: rects second right = rects third left.
	self assert: rects third right = bar right.
! !

!OBButtonBarTest methodsFor: 'testing' stamp: 'cwp 3/11/2007 16:53'!
testPush1
	self push: 'Command 1'.
	self assert: received = #cmd1! !

!OBButtonBarTest methodsFor: 'testing' stamp: 'cwp 3/11/2007 17:06'!
testPush4
	self push: 'Command 4'.
	self assert: received isNil! !

OBBarMorphTest subclass: #OBRadioButtonBarTest
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Morphic'!

!OBRadioButtonBarTest methodsFor: 'asserting' stamp: 'cwp 11/27/2004 18:03'!
assertSelectionIs: anInteger
	self assert: selection = anInteger.
	bar submorphs withIndexDo: 
		[:button :index |
		index = anInteger
			ifTrue: [self assert: button isOn]
			ifFalse: [self deny: button isOn]]! !

!OBRadioButtonBarTest methodsFor: 'callbacks' stamp: 'cwp 2/22/2004 17:42'!
list
	^ #('alpha' 'beta' 'gamma')! !

!OBRadioButtonBarTest methodsFor: 'callbacks' stamp: 'cwp 2/22/2004 16:39'!
selection
	^ selection! !

!OBRadioButtonBarTest methodsFor: 'callbacks' stamp: 'cwp 2/24/2004 19:31'!
selection: anInteger
	selection _ anInteger.
	self changed: #selection! !

!OBRadioButtonBarTest methodsFor: 'running' stamp: 'cwp 11/27/2004 18:03'!
setUp
	selection _ 0.
	bar _ OBRadioButtonBar
			on: self
			list: #list
			selected: #selection
			changeSelected: #selection:.
! !

!OBRadioButtonBarTest methodsFor: 'testing' stamp: 'cwp 3/11/2007 15:57'!
testLayout
	| rects |
	
	"This is an ugly hack. I can't figure out how else to force a layout."
	bar openInWorld.
	self changed: #list.
	bar bounds: (100@100 corner: 400@140).
	bar delete.

	rects _ bar submorphs collect: [:b | b bounds].
	self assert: rects first left = bar left.
	self assert: rects first right = rects second left.
	self assert: rects second right = rects third left.
	self assert: rects third right = bar right.
! !

!OBRadioButtonBarTest methodsFor: 'testing' stamp: 'cwp 2/22/2004 16:53'!
testList
	self assert: bar list = self list! !

!OBRadioButtonBarTest methodsFor: 'testing' stamp: 'cwp 2/24/2004 19:35'!
testPushAlphaBeta
	self changed: #list.
	self push: 'alpha'.
	self assertSelectionIs: 1.
	self push: 'beta'.
	self assertSelectionIs: 2.! !

!OBRadioButtonBarTest methodsFor: 'testing' stamp: 'cwp 11/27/2004 18:04'!
testUpdateList
	| labels |
	self changed: #list.
	labels _ bar submorphs collect: [:b | b label contents].
	self assert: labels size = self list size.
	self assert: (labels includesAllOf: self list)! !

!OBRadioButtonBarTest methodsFor: 'testing' stamp: 'cwp 2/24/2004 19:15'!
testUpdateSelection
	self changed: #list.
	selection _ 2.
	self changed: #selection.
	self assertSelectionIs: 2.! !

TestCase subclass: #OBKeyBindingsTest
	instanceVariableNames: 'ptm message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Morphic'!

!OBKeyBindingsTest methodsFor: 'asserting' stamp: 'cwp 10/31/2004 00:36'!
assert: evt sends: aSelector
	ptm keyStroke: evt.
	self assert: message notNil.
	self assert: message selector = aSelector.
	self assert: message arguments size = 1.
	self assert: message arguments first = #OBBrowser.! !

!OBKeyBindingsTest methodsFor: 'callbacks' stamp: 'cwp 10/30/2004 23:58'!
browseIt: aSelector
	message _ self thisMessage.
	^ true! !

!OBKeyBindingsTest methodsFor: 'callbacks' stamp: 'cwp 10/31/2004 00:39'!
implementorsOfIt: aSelector
	message _ self thisMessage.
	^ true! !

!OBKeyBindingsTest methodsFor: 'keystrokes' stamp: 'cwp 10/31/2004 01:08'!
ksCmdB
	^ self modifier: 64 keycode: 98! !

!OBKeyBindingsTest methodsFor: 'keystrokes' stamp: 'cwp 10/31/2004 01:08'!
ksCmdM
	^ self modifier: 64 keycode: 109! !

!OBKeyBindingsTest methodsFor: 'keystrokes' stamp: 'cwp 10/31/2004 01:08'!
ksCmdN
	^ self modifier: 64 keycode: 110! !

!OBKeyBindingsTest methodsFor: 'keystrokes' stamp: 'cwp 10/31/2004 01:09'!
ksCmdShiftE
	^ self modifier: 72 keycode: 69
! !

!OBKeyBindingsTest methodsFor: 'keystrokes' stamp: 'cwp 10/31/2004 01:09'!
ksCmdShiftN
	^ self modifier: 72 keycode: 78! !

!OBKeyBindingsTest methodsFor: 'keystrokes' stamp: 'cwp 10/31/2004 01:09'!
ksCmdShiftW
	^ self modifier: 72 keycode: 87! !

!OBKeyBindingsTest methodsFor: 'keystrokes' stamp: 'cwp 10/31/2004 01:07'!
modifier: mod keycode: code
	| string |
	string := 'keystroke 988180 ', mod asString, ' ', code asString.
	^ KeyboardEvent readFrom: string readStream! !

!OBKeyBindingsTest methodsFor: 'callbacks' stamp: 'cwp 10/31/2004 00:49'!
referencesToIt: aSelector
	message := self thisMessage.
	^ true! !

!OBKeyBindingsTest methodsFor: 'callbacks' stamp: 'cwp 10/30/2004 23:26'!
selection
	^ 1 to: 9! !

!OBKeyBindingsTest methodsFor: 'callbacks' stamp: 'cwp 10/31/2004 00:25'!
sendersOfIt: aSelector
	message := self thisMessage.
	^ true! !

!OBKeyBindingsTest methodsFor: 'running' stamp: 'cwp 10/30/2004 22:05'!
setUp
	ptm := (OBPluggableTextMorph
			on: self
			text: #text
			accept: #accept:notifying:
			readSelection: #selection
			menu: #menu:shifted:)
				font: Preferences standardCodeFont;
				yourself! !

!OBKeyBindingsTest methodsFor: 'tests' stamp: 'cwp 10/31/2004 00:33'!
testBrowseIt
	self assert: self ksCmdB sends: #browseIt:! !

!OBKeyBindingsTest methodsFor: 'tests' stamp: 'cwp 10/31/2004 00:35'!
testImplementorsOfIt
	self assert: self ksCmdM sends: #implementorsOfIt:! !

!OBKeyBindingsTest methodsFor: 'tests' stamp: 'cwp 10/31/2004 00:44'!
testReferencesToIt
	self assert: self ksCmdShiftN sends: #referencesToIt:! !

!OBKeyBindingsTest methodsFor: 'tests' stamp: 'cwp 10/31/2004 00:35'!
testSendersOfIt
	self assert: self ksCmdN sends: #sendersOfIt:! !

!OBKeyBindingsTest methodsFor: 'callbacks' stamp: 'cwp 10/30/2004 23:26'!
text
	^ 'OBBrowser'! !

!OBKeyBindingsTest methodsFor: 'callbacks' stamp: 'cwp 10/30/2004 23:57'!
thisMessage
	| context args |
	context := thisContext sender.
	args := Array new: context size.
	1 to: args size do: [:i | args at: i put: (context at: 1)].
	^ Message 
		selector: context method selector
		arguments: args ! !

TestCase subclass: #OBPaneLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Morphic'!

!OBPaneLayoutTest methodsFor: 'callbacks' stamp: 'cwp 11/2/2004 00:37'!
buttonMorph
	^ RectangleMorph new
		color: Color red;
		yourself! !

!OBPaneLayoutTest methodsFor: 'callbacks' stamp: 'cwp 5/3/2007 21:08'!
dragEnabled
	^ false! !

!OBPaneLayoutTest methodsFor: 'callbacks' stamp: 'cwp 5/3/2007 21:08'!
dropEnabled
	^ false! !

!OBPaneLayoutTest methodsFor: 'emulating' stamp: 'cwp 5/31/2007 21:00'!
isActive
	^ true! !

!OBPaneLayoutTest methodsFor: 'callbacks' stamp: 'cwp 5/3/2007 21:11'!
list
	^ #('a' 'b' 'c')! !

!OBPaneLayoutTest methodsFor: 'callbacks' stamp: 'cwp 11/2/2004 00:34'!
listMorph
	^ RectangleMorph new
! !

!OBPaneLayoutTest methodsFor: 'callbacks' stamp: 'cwp 5/3/2007 21:07'!
selection
	^ 0! !

!OBPaneLayoutTest methodsFor: 'testing' stamp: 'cwp 5/21/2007 22:24'!
testButtonPlacement
	| pane button builder |
	builder _ OBMorphBuilder new.
	pane :=  builder column: self with: [builder switch: self with: []].
	pane bounds: (0@0 corner: 200@400).
	button := pane submorphs at: 1.
	self assert: button top = 377.
	self assert: button bottom = 400.
	self assert: button left = pane left.
	self assert: button right = pane right.! !

TestCase subclass: #OBPaneScrollerTest
	instanceVariableNames: 'paneCount scroller'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Morphic'!

!OBPaneScrollerTest methodsFor: 'actions' stamp: 'cwp 3/25/2007 00:30'!
buildOn: aBuilder
	^ RectangleMorph new
		bounds: (10@10 corner: 20@20);
		yourself! !

!OBPaneScrollerTest methodsFor: 'callbacks' stamp: 'cwp 3/25/2007 00:31'!
columns
	^ ((1 to: paneCount) collect: [:i | self]) asOrderedCollection! !

!OBPaneScrollerTest methodsFor: 'actions' stamp: 'cwp 11/2/2004 00:00'!
createPane
	^ RectangleMorph new
		bounds: (10@10 corner: 20@20);
		yourself! !

!OBPaneScrollerTest methodsFor: 'actions' stamp: 'cwp 11/21/2004 22:40'!
createScroller
	scroller := OBPaneScroller withModel: self.
	scroller bounds: (10 @ 420 extent: 600 @ 160)! !

!OBPaneScrollerTest methodsFor: 'callbacks' stamp: 'cwp 11/21/2004 12:55'!
panes
	^ ((1 to: paneCount) collect: [:i | self createPane]) asOrderedCollection! !

!OBPaneScrollerTest methodsFor: 'callbacks' stamp: 'cwp 11/23/2004 01:37'!
reclaimPanes
	^ scroller panes size - 4! !

!OBPaneScrollerTest methodsFor: 'callbacks' stamp: 'cwp 11/17/2004 23:39'!
sizing
	^ 4! !

!OBPaneScrollerTest methodsFor: 'tests' stamp: 'cwp 11/21/2004 22:40'!
testPaneHeightNoScrollBar
	paneCount := 4.
	self createScroller.
	self assert: scroller paneHeight = 160! !

!OBPaneScrollerTest methodsFor: 'tests' stamp: 'cwp 11/21/2004 22:40'!
testPaneHeightWithScrollBar
	paneCount := 5.
	self createScroller.
	self assert: scroller paneHeight = 147! !

!OBPaneScrollerTest methodsFor: 'tests' stamp: 'cwp 5/31/2007 21:10'!
testPaneReclamation
	paneCount := 6.
	self createScroller.
	scroller submorphs first setValue: 0.2.
	paneCount := 4.
	scroller update: #columns.
	self assert: scroller panes size = 4! !

!OBPaneScrollerTest methodsFor: 'tests' stamp: 'cwp 11/21/2004 23:11'!
testResizeUpdatesPaneHeight
	paneCount := 4.
	self createScroller.
	self assert: scroller panes first height = 160.
	scroller bounds: (scroller bounds outsetBy: 1).
	self assert: scroller panes first height = 162! !

!OBPaneScrollerTest methodsFor: 'tests' stamp: 'cwp 11/21/2004 23:09'!
testResizeUpdatesPaneWidth
	paneCount := 4.
	self createScroller.
	self assert: scroller panes first width = 147.
	scroller bounds: (scroller bounds outsetBy: 2).
	self assert: scroller panes first width = 148! !

OBBuilderTest subclass: #OBMorphBuilderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Morphic'!

!OBMorphBuilderTest methodsFor: 'emulating' stamp: 'cwp 5/17/2007 22:38'!
activate
	! !

!OBMorphBuilderTest methodsFor: 'accessing' stamp: 'cwp 3/13/2007 22:30'!
builder
	^ OBMorphBuilder new! !

!OBMorphBuilderTest methodsFor: 'emulating' stamp: 'cwp 3/15/2007 22:37'!
displayString
	^ 'test'! !

!OBMorphBuilderTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/20/2007 20:20'!
displayStringForChild: aNode 
	^ aNode displayString! !

!OBMorphBuilderTest methodsFor: 'emulating' stamp: 'cwp 3/24/2007 00:48'!
isEnabled: aButton
	^ true! !

!OBMorphBuilderTest methodsFor: 'emulating' stamp: 'cwp 3/24/2007 00:49'!
isSelected: aButton
	^ false! !

!OBMorphBuilderTest methodsFor: 'emulating' stamp: 'cwp 5/17/2007 22:38'!
list
	^ #(a b c)! !

!OBMorphBuilderTest methodsFor: 'emulating' stamp: 'cwp 5/17/2007 22:38'!
selection
	^ 1! !

!OBMorphBuilderTest methodsFor: 'tests' stamp: 'cwp 3/13/2007 22:27'!
tests01BrowserCreatesWindow
	| morph |
	morph _ self buildWindow.
	self assert: (morph isKindOf: SystemWindow).
	self assert: (morph model == model).! !

!OBMorphBuilderTest methodsFor: 'tests' stamp: 'cwp 3/18/2007 23:32'!
tests02BrowserAddsPanelGroups
	| widget |
	widget _ self buildWindow.
	self assert: widget submorphs size = 3.
	self assert: (widget submorphs second isKindOf: RectangleMorph).
	self assert: (widget submorphs third isKindOf: RectangleMorph).! !

!OBMorphBuilderTest methodsFor: 'tests' stamp: 'cwp 3/18/2007 23:45'!
tests02BrowserAddsPanels
	| morphs |
	morphs _ self buildWindow submorphs gather: [:ea | ea submorphs].
	morphs _ morphs select: [:ea | ea respondsTo: #model].
	self assert: (morphs anySatisfy: [:ea | ea model isKindOf: OBColumnPanel]).
	self assert: (morphs anySatisfy: [:ea | ea model isKindOf: OBDefinitionPanel]).! !

!OBMorphBuilderTest methodsFor: 'tests' stamp: 'cwp 3/15/2007 23:11'!
tests03ColumnPanelAddsColumns
	| morph panes |
	morph _ self buildNavigationPanel.
	panes _ morph submorphs first submorphs.
	self assert: (morph model isKindOf: OBColumnPanel).
	self assert: panes  size = 7.
	(1 to: 7 by: 2) do: [:ea | self assert: ((panes at: ea) isKindOf: OBPane)].
	! !

!OBMorphBuilderTest methodsFor: 'tests' stamp: 'cwp 3/15/2007 22:55'!
tests04ColumnAddsList
	| morph |
	morph _ self build: self columnWithFilter.
	self assert: (morph isKindOf: OBPane).
	self assert: (morph submorphs last isKindOf: PluggableListMorph)! !

!OBMorphBuilderTest methodsFor: 'tests' stamp: 'cwp 3/15/2007 22:55'!
tests05ColumnAddsButton
	| morph |
	morph _ self build: self columnWithFilter.
	self assert: (morph isKindOf: OBPane).
	self assert: (morph submorphs first isKindOf: OBRadioButtonBar)! !

!OBMorphBuilderTest methodsFor: 'tests' stamp: 'cwp 3/23/2007 22:47'!
tests06TwoGroupSpecialCase
	| widget |
	widget _ self buildWindow.
	self assert: widget submorphs size = 3.
	self assert: (widget submorphs second layoutFrame bottomFraction = 0.4).
	self assert: (widget submorphs third layoutFrame topFraction = 0.4).
! !

!OBMorphBuilderTest methodsFor: 'tests' stamp: 'cwp 3/24/2007 00:50'!
tests07ButtonModelCanBeBuiltAlone
	| morph |
	model _ OBButtonModel withLabel: 'test' inBar: self.
	morph _ OBMorphBuilder build: model.
	self assert: (morph isKindOf: PluggableButtonMorph).! !

!OBMorphBuilderTest methodsFor: 'tests' stamp: 'cwp 5/17/2007 22:38'!
tests08SwitchCanBeBuiltAlone
	| morph |
	model _ OBSwitch new.
	model filter: self.
	morph _ OBMorphBuilder build: model.
	self assert: (morph isKindOf: OBRadioButtonBar).! !
